darcs-2.12.5: a distributed, interactive, smart revision control system

Copyright | 2008 Eric Kow
License | GPL
Maintainer | darcs-devel@darcs.net
Stability | experimental
Portability | portable
Safe Haskell | Safe
Language | Haskell2010

Darcs.Util.English

Description

This modules provides rudimentary natural language generation (NLG) utilities. That is, generating natural language from a machine representation. Initially, only English is supported at all. Representations are implemented for:

- countable nouns (plurality); and
- lists of clauses (foo, bar and/or baz).

Synopsis

- englishNum :: Countable n => Int -> n -> ShowS
- class Countable a where
- newtype Noun = Noun String
- data Pronoun = It
- data This = This Noun
- andClauses :: [String] -> String
- orClauses :: [String] -> String
- itemize :: String -> [String] -> String
- presentParticiple :: String -> String
- capitalize :: String -> String

# Documentation

englishNum :: Countable n => Int -> n -> ShowS #

    englishNum 0 (Noun "watch") "" == "watches"
    englishNum 1 (Noun "watch") "" == "watch"
    englishNum 2 (Noun "watch") "" == "watches"

class Countable a where #

Things that have a plural and singular spelling

Minimal complete definition

plural, singular

Methods

plural :: a -> ShowS #

singular :: a -> ShowS #

Instances

Countable This # |
Methods plural :: This -> ShowS # singular :: This -> ShowS #
Countable Pronoun # |
Methods plural :: Pronoun -> ShowS # singular :: Pronoun -> ShowS #
Countable Noun # |
Methods plural :: Noun -> ShowS # singular :: Noun -> ShowS #

newtype Noun #

This only distinguishes between nouns with a final -ch, and nouns which do not. More irregular nouns will just need to have their own type

    plural (Noun "batch") "" == "batches"
    plural (Noun "bat")   "" == "bats"
    plural (Noun "mouse") "" == "mouses" -- :-(

Constructors

Noun String |

Instances

Countable Noun # |
Methods plural :: Noun -> ShowS # singular :: Noun -> ShowS #

data Pronoun #

Constructors

It |

Instances

Countable Pronoun # |
Methods plural :: Pronoun -> ShowS # singular :: Pronoun -> ShowS #

data This #

    singular This (Noun "batch") "" == "this batch"
    plural   This (Noun "batch") "" == "these batches"

Constructors

This Noun |

Instances

Countable This # |
Methods plural :: This -> ShowS # singular :: This -> ShowS #

andClauses :: [String] -> String #

Given a list of things, combine them thusly:

    orClauses ["foo", "bar", "baz"] == "foo, bar or baz"

orClauses :: [String] -> String #

Given a list of things, combine them thusly:

    orClauses ["foo", "bar", "baz"] == "foo, bar or baz"

itemize :: String -> [String] -> String #

presentParticiple :: String -> String #

capitalize :: String -> String #

Capitalize the first letter of a word